Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34921)
@@ -3094,5 +2235,5 @@
                 # use different base if necessary for some offsets (Minolta A200)
                 if ($$tagInfo{WrongBase}) {
-                    my $self = $exifTool;
+                    my $self = $et;
                     #### eval WrongBase ($self)
                     $wrongBase = eval $$tagInfo{WrongBase} || 0;
@@ -3113,5 +2254,5 @@
                         $oldEnd = $$oldOffset[$n] + $$oldSize[$n];
                         # update TIFF_END as if we read this data from file
-                        UpdateTiffEnd($exifTool, $oldEnd + $dbase);
+                        UpdateTiffEnd($et, $oldEnd + $dbase);
                     }
                     my $offsetPos = $offsets + $n * 4;
@@ -3128,5 +2269,5 @@
                         $offset -= $dpos;
                     } elsif ($size != 0xfeedfeed) {
-                        $exifTool->Error('Internal error (no offset)');
+                        $et->Error('Internal error (no offset)');
                         return undef;
                     }
@@ -3136,18 +2277,18 @@
                     if ($size == 0xfeedfeed) {
                         unless (defined $dataTag) {
-                            $exifTool->Error("No DataTag defined for $$tagInfo{Name}");
+                            $et->Error("No DataTag defined for $$tagInfo{Name}");
                             return undef;
                         }
                         unless (defined $offsetData{$dataTag}) {
-                            $exifTool->Error("Internal error (no $dataTag)");
+                            $et->Error("Internal error (no $dataTag)");
                             return undef;
                         }
                         if ($count > 1) {
-                            $exifTool->Error("Can't modify $$tagInfo{Name} with count $count");
+                            $et->Error("Can't modify $$tagInfo{Name} with count $count");
                             return undef;
                         }
                         $buff = $offsetData{$dataTag};
                         if ($formatSize[$format] != 4) {
-                            $exifTool->Error("$$cntInfo{Name} is not int32");
+                            $et->Error("$$cntInfo{Name} is not int32");
                             return undef;
                         }
@@ -3158,6 +2299,6 @@
                         # pad if necessary (but don't pad contiguous image blocks)
                         my $pad = 0;
-                        ++$pad if $size & 0x01 and ($n+1 >= $count or not $oldEnd or
-                                  $oldEnd != $$oldOffset[$n+1]);
+                        ++$pad if ($blockSize + $size) & 0x01 and ($n+1 >= $count or
+                                  not $oldEnd or $oldEnd != $$oldOffset[$n+1]);
                         # preserve original image padding if specified
                         if ($$origDirInfo{PreserveImagePadding} and $n+1 < $count and
@@ -3180,5 +2321,5 @@
                         # take data from old dir data buffer
                         $buff = substr($$dataPt, $offset, $size);
-                    } elsif ($$exifTool{TIFF_TYPE} eq 'MRW') {
+                    } elsif ($$et{TIFF_TYPE} eq 'MRW') {
                         # TTW segment must be an even 4 bytes long, so pad now if necessary
                         my $n = length $newData;
@@ -3193,6 +2334,6 @@
                         # (data was read OK)
                         # patch incorrect ThumbnailOffset in Sony A100 1.00 ARW images
-                        if ($$exifTool{TIFF_TYPE} eq 'ARW' and $$tagInfo{Name} eq 'ThumbnailOffset' and
-                            $$exifTool{Model} eq 'DSLR-A100' and $buff !~ /^\xff\xd8\xff/)
+                        if ($$et{TIFF_TYPE} eq 'ARW' and $$tagInfo{Name} eq 'ThumbnailOffset' and
+                            $$et{Model} eq 'DSLR-A100' and $buff !~ /^\xff\xd8\xff/)
                         {
                             my $pos = $offset + $dbase + $dpos;
@@ -3202,7 +2343,7 @@
                             {
                                 $buff = $try;
-                                $exifTool->Warn('Adjusted incorrect A100 ThumbnailOffset', 1);
+                                $et->Warn('Adjusted incorrect A100 ThumbnailOffset', 1);
                             } else {
-                                $exifTool->Error('Invalid ThumbnailImage');
+                                $et->Error('Invalid ThumbnailImage');
                             }
                         }
@@ -3210,5 +2351,5 @@
                         # Grrr.  The Canon 350D writes the thumbnail with an incorrect byte count
                         my $diff = $offset + $size - $dataLen;
-                        $exifTool->Warn("ThumbnailImage runs outside EXIF data by $diff bytes (truncated)",1);
+                        $et->Warn("ThumbnailImage runs outside EXIF data by $diff bytes (truncated)",1);
                         # set the size to the available data
                         $size -= $diff;
@@ -3218,8 +2359,8 @@
                         # get the truncated image
                         $buff = substr($$dataPt, $offset, $size);
-                    } elsif ($$tagInfo{Name} eq 'PreviewImageStart' and $exifTool->{FILE_TYPE} eq 'JPEG') {
+                    } elsif ($$tagInfo{Name} eq 'PreviewImageStart' and $$et{FILE_TYPE} eq 'JPEG') {
                         # try to load the preview image using the specified offset
                         undef $buff;
-                        my $r = $exifTool->{RAF};
+                        my $r = $$et{RAF};
                         if ($r and not $raf) {
                             my $tell = $r->Tell();
@@ -3227,6 +2368,6 @@
                             undef $buff unless $r->Seek($offset+$base+$dataPos,0) and
                                                $r->Read($buff,$size) == $size and
-                                               $buff =~ /^.\xd8\xff[\xc4\xdb\xe0-\xef]/;
-                            $r->Seek($tell, 0) or $exifTool->Error('Seek error'), return undef;
+                                               $buff =~ /^.\xd8\xff[\xc4\xdb\xe0-\xef]/s;
+                            $r->Seek($tell, 0) or $et->Error('Seek error'), return undef;
                         }
                         # set flag if we must load PreviewImage
@@ -3234,21 +2375,27 @@
                     } else {
                         my $dataName = $dataTag || $$tagInfo{Name};
-                        return undef if $exifTool->Error("Error reading $dataName data in $name", $inMakerNotes);
+                        return undef if $et->Error("Error reading $dataName data in $name", $inMakerNotes);
                         $buff = '';
                     }
                     if ($$tagInfo{Name} eq 'PreviewImageStart') {
-                        if ($$exifTool{FILE_TYPE} eq 'JPEG' and not $$tagInfo{MakerPreview}) {
+                        if ($$et{FILE_TYPE} eq 'JPEG' and not $$tagInfo{MakerPreview}) {
                             # hold onto the PreviewImage until we can determine if it fits
-                            $exifTool->{PREVIEW_INFO} or $exifTool->{PREVIEW_INFO} = { };
-                            $exifTool->{PREVIEW_INFO}{Data} = $buff;
+                            $$et{PREVIEW_INFO} or $$et{PREVIEW_INFO} = {
+                                Data => $buff,
+                                Fixup => new Image::ExifTool::Fixup,
+                            };
                             if ($$tagInfo{IsOffset} and $$tagInfo{IsOffset} eq '2') {
-                                $exifTool->{PREVIEW_INFO}{NoBaseShift} = 1;
+                                $$et{PREVIEW_INFO}{NoBaseShift} = 1;
+                            }
+                            if ($offset >= 0 and $offset+$size <= $dataLen) {
+                                # set flag indicating this preview wasn't in a trailer
+                                $$et{PREVIEW_INFO}{WasContained} = 1;
                             }
                             $buff = '';
-                        } elsif ($$exifTool{TIFF_TYPE} eq 'ARW' and $$exifTool{Model}  eq 'DSLR-A100') {
+                        } elsif ($$et{TIFF_TYPE} eq 'ARW' and $$et{Model}  eq 'DSLR-A100') {
                             # the A100 double-references the same preview, so ignore the
                             # second one (the offset and size will be patched later)
-                            next if $$exifTool{A100PreviewLength};
-                            $$exifTool{A100PreviewLength} = length $buff if defined $buff;
+                            next if $$et{A100PreviewLength};
+                            $$et{A100PreviewLength} = length $buff if defined $buff;
                         }
                     }
@@ -3278,5 +2425,5 @@
         # verify that nothing else got written after determining TTW length
         if (defined $ttwLen and $ttwLen != length($newData)) {
-            $exifTool->Error('Internal error writing MRW TTW');
+            $et->Error('Internal error writing MRW TTW');
         }
     }
@@ -3290,5 +2437,5 @@
             my $format = Get16u(\$newData, $entry + 2);
             if ($format < 1 or $format > 13) {
-                $exifTool->Error('Internal error copying huge value');
+                $et->Error('Internal error copying huge value');
                 last;
             } else {
@@ -3302,5 +2449,5 @@
                     $subIfdDataFixup->AddFixup($entry + 8);
                     # save fixup in imageData list
-                    $$blockInfo[4] = $subIfdDataFixup; 
+                    $$blockInfo[4] = $subIfdDataFixup;
                 }
                 # must reset entry pointer so we don't use it again in a parent IFD!
@@ -3313,5 +2460,5 @@
             # but it will actually be at length($newData) + $blockSize.  So adjust
             # accordingly (and subtract an extra Start because this shift is applied later)
-            $subFix->{Shift} += length($newData) - $$subFix{BlockLen} - 2 * $$subFix{Start} + $blockSize;
+            $$subFix{Shift} += length($newData) - $$subFix{BlockLen} - 2 * $$subFix{Start} + $blockSize;
             $subFix->ApplyFixup(\$newData);
         }
@@ -3332,46 +2479,43 @@
         $fixup->SetMarkerPointers(\$newData, 'CanonVRD', length($newData) + $blockSize);
         if ($newDataPos) {
-            $fixup->{Shift} += $newDataPos;
+            $$fixup{Shift} += $newDataPos;
             $fixup->ApplyFixup(\$newData);
         }
         # save fixup for adjusting Leica trailer offset if necessary
-        if ($$exifTool{LeicaTrailer}) {
-            my $trail = $$exifTool{LeicaTrailer};
-            $$trail{Fixup} or $$trail{Fixup} = new Image::ExifTool::Fixup;
-            $$trail{Fixup}->AddFixup($fixup);
-        }
+        $$et{LeicaTrailer}{Fixup}->AddFixup($fixup) if $$et{LeicaTrailer};
         # save fixup for PreviewImage in JPEG file if necessary
-        my $previewInfo = $exifTool->{PREVIEW_INFO};
+        my $previewInfo = $$et{PREVIEW_INFO};
         if ($previewInfo) {
-            my $pt = \$previewInfo->{Data}; # image data or 'LOAD_PREVIEW' flag
+            my $pt = \$$previewInfo{Data}; # image data or 'LOAD_PREVIEW' flag
             # now that we know the size of the EXIF data, first test to see if our new image fits
             # inside the EXIF segment (remember about the TIFF and EXIF headers: 8+6 bytes)
             if (($$pt ne 'LOAD_PREVIEW' and length($$pt) + length($newData) + 14 <= 0xfffd and
-                not $previewInfo->{IsTrailer}) or
-                $previewInfo->{IsShort}) # must fit in this segment if using short pointers
+                not $$previewInfo{IsTrailer}) or
+                $$previewInfo{IsShort}) # must fit in this segment if using short pointers
             {
                 # It fits! (or must exist in EXIF segment), so fixup the
                 # PreviewImage pointers and stuff the preview image in here
                 my $newPos = length($newData) + $newDataPos;
-                $newPos += ($previewInfo->{BaseShift} || 0);
-                if ($previewInfo->{Relative}) {
+                $newPos += ($$previewInfo{BaseShift} || 0);
+                if ($$previewInfo{Relative}) {
                     # calculate our base by looking at how far the pointer got shifted
-                    $newPos -= $fixup->GetMarkerPointers(\$newData, 'PreviewImage');
+                    $newPos -= ($fixup->GetMarkerPointers(\$newData, 'PreviewImage') || 0);
                 }
                 $fixup->SetMarkerPointers(\$newData, 'PreviewImage', $newPos);
                 $newData .= $$pt;
-                delete $exifTool->{PREVIEW_INFO};   # done with our preview data
-                $exifTool->{DEL_PREVIEW} = 1;       # set flag to delete old preview
+                # set flag to delete old preview unless it was contained in the EXIF
+                $$et{DEL_PREVIEW} = 1 unless $$et{PREVIEW_INFO}{WasContained};
+                delete $$et{PREVIEW_INFO};   # done with our preview data
             } else {
                 # Doesn't fit, or we still don't know, so save fixup information
                 # and put the preview at the end of the file
-                $previewInfo->{Fixup} or $previewInfo->{Fixup} = new Image::ExifTool::Fixup;
-                $previewInfo->{Fixup}->AddFixup($fixup);
+                $$previewInfo{Fixup} or $$previewInfo{Fixup} = new Image::ExifTool::Fixup;
+                $$previewInfo{Fixup}->AddFixup($fixup);
             }
         } elsif (defined $newData and $deleteAll) {
             $newData = '';  # delete both IFD0 and IFD1 since only mandatory tags remain
-        } elsif ($$exifTool{A100PreviewLength}) {
+        } elsif ($$et{A100PreviewLength}) {
             # save preview image start for patching A100 quirks later
-            $$exifTool{A100PreviewStart} = $fixup->GetMarkerPointers(\$newData, 'PreviewImage');
+            $$et{A100PreviewStart} = $fixup->GetMarkerPointers(\$newData, 'PreviewImage');
         }
         # save location of last IFD for use in Canon RAW header
@@ -3381,8 +2525,8 @@
         }
         # recrypt SR2 SubIFD data if necessary
-        my $key = $$exifTool{SR2SubIFDKey};
+        my $key = $$et{SR2SubIFDKey};
         if ($key) {
             my $start = $fixup->GetMarkerPointers(\$newData, 'SR2SubIFDOffset');
-            my $len = $$exifTool{SR2SubIFDLength};
+            my $len = $$et{SR2SubIFDLength};
             # (must subtract 8 for size of TIFF header)
             if ($start and $start - 8 + $len <= length $newData) {
@@ -3396,4 +2540,7 @@
     $newData = '' if defined $newData and length($newData) < 12;
 
+    # set changed if ForceWrite tag was set to "EXIF"
+    ++$$et{CHANGED} if defined $newData and length $newData and $$et{FORCE_WRITE}{EXIF};
+
     return $newData;    # return our directory data
 }
@@ -3417,5 +2564,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
